(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require HighOrd.
Require bool.Bool.
Require int.Int.
Require int.Abs.
Require int.ComputerDivision.
Require real.Real.
Require real.RealInfix.
Require real.FromInt.
Require map.Map.

Parameter eqb:
  forall {a:Type} {a_WT:WhyType a}, a -> a -> Init.Datatypes.bool.

Axiom eqb1 :
  forall {a:Type} {a_WT:WhyType a},
  forall (x:a) (y:a), ((eqb x y) = Init.Datatypes.true) <-> (x = y).

Axiom eqb_false :
  forall {a:Type} {a_WT:WhyType a},
  forall (x:a) (y:a), ((eqb x y) = Init.Datatypes.false) <-> ~ (x = y).

Parameter neqb:
  forall {a:Type} {a_WT:WhyType a}, a -> a -> Init.Datatypes.bool.

Axiom neqb1 :
  forall {a:Type} {a_WT:WhyType a},
  forall (x:a) (y:a), ((neqb x y) = Init.Datatypes.true) <-> ~ (x = y).

Parameter zlt: Numbers.BinNums.Z -> Numbers.BinNums.Z -> Init.Datatypes.bool.

Parameter zleq:
  Numbers.BinNums.Z -> Numbers.BinNums.Z -> Init.Datatypes.bool.

Axiom zlt1 :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((zlt x y) = Init.Datatypes.true) <-> (x < y)%Z.

Axiom zleq1 :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((zleq x y) = Init.Datatypes.true) <-> (x <= y)%Z.

Parameter rlt:
  Reals.Rdefinitions.R -> Reals.Rdefinitions.R -> Init.Datatypes.bool.

Parameter rleq:
  Reals.Rdefinitions.R -> Reals.Rdefinitions.R -> Init.Datatypes.bool.

Axiom rlt1 :
  forall (x:Reals.Rdefinitions.R) (y:Reals.Rdefinitions.R),
  ((rlt x y) = Init.Datatypes.true) <-> (x < y)%R.

Axiom rleq1 :
  forall (x:Reals.Rdefinitions.R) (y:Reals.Rdefinitions.R),
  ((rleq x y) = Init.Datatypes.true) <-> (x <= y)%R.

(* Why3 assumption *)
Definition real_of_int (x:Numbers.BinNums.Z) : Reals.Rdefinitions.R :=
  BuiltIn.IZR x.

Axiom c_euclidian :
  forall (n:Numbers.BinNums.Z) (d:Numbers.BinNums.Z), ~ (d = 0%Z) ->
  (n = (((ZArith.BinInt.Z.quot n d) * d)%Z + (ZArith.BinInt.Z.rem n d))%Z).

Axiom cmod_remainder :
  forall (n:Numbers.BinNums.Z) (d:Numbers.BinNums.Z),
  ((0%Z <= n)%Z -> (0%Z < d)%Z ->
   (0%Z <= (ZArith.BinInt.Z.rem n d))%Z /\ ((ZArith.BinInt.Z.rem n d) < d)%Z) /\
  ((n <= 0%Z)%Z -> (0%Z < d)%Z ->
   ((-d)%Z < (ZArith.BinInt.Z.rem n d))%Z /\
   ((ZArith.BinInt.Z.rem n d) <= 0%Z)%Z) /\
  ((0%Z <= n)%Z -> (d < 0%Z)%Z ->
   (0%Z <= (ZArith.BinInt.Z.rem n d))%Z /\
   ((ZArith.BinInt.Z.rem n d) < (-d)%Z)%Z) /\
  ((n <= 0%Z)%Z -> (d < 0%Z)%Z ->
   (d < (ZArith.BinInt.Z.rem n d))%Z /\ ((ZArith.BinInt.Z.rem n d) <= 0%Z)%Z).

Axiom cdiv_neutral :
  forall (a:Numbers.BinNums.Z), ((ZArith.BinInt.Z.quot a 1%Z) = a).

Axiom cdiv_inv :
  forall (a:Numbers.BinNums.Z), ~ (a = 0%Z) ->
  ((ZArith.BinInt.Z.quot a a) = 1%Z).

Axiom cdiv_closed_remainder :
  forall (a:Numbers.BinNums.Z) (b:Numbers.BinNums.Z) (n:Numbers.BinNums.Z),
  (0%Z <= a)%Z -> (0%Z <= b)%Z ->
  (0%Z <= (b - a)%Z)%Z /\ ((b - a)%Z < n)%Z ->
  ((ZArith.BinInt.Z.rem a n) = (ZArith.BinInt.Z.rem b n)) -> (a = b).

(* Why3 assumption *)
Inductive addr :=
  | addr'mk : Numbers.BinNums.Z -> Numbers.BinNums.Z -> addr.
Axiom addr_WhyType : WhyType addr.
Existing Instance addr_WhyType.

(* Why3 assumption *)
Definition base (v:addr) : Numbers.BinNums.Z :=
  match v with
  | addr'mk x x1 => x
  end.

(* Why3 assumption *)
Definition offset (v:addr) : Numbers.BinNums.Z :=
  match v with
  | addr'mk x x1 => x1
  end.

Parameter addr_le: addr -> addr -> Prop.

Parameter addr_lt: addr -> addr -> Prop.

Parameter addr_le_bool: addr -> addr -> Init.Datatypes.bool.

Parameter addr_lt_bool: addr -> addr -> Init.Datatypes.bool.

Axiom addr_le_def :
  forall (p:addr) (q:addr), ((base p) = (base q)) ->
  addr_le p q <-> ((offset p) <= (offset q))%Z.

Axiom addr_lt_def :
  forall (p:addr) (q:addr), ((base p) = (base q)) ->
  addr_lt p q <-> ((offset p) < (offset q))%Z.

Axiom addr_le_bool_def :
  forall (p:addr) (q:addr),
  addr_le p q <-> ((addr_le_bool p q) = Init.Datatypes.true).

Axiom addr_lt_bool_def :
  forall (p:addr) (q:addr),
  addr_lt p q <-> ((addr_lt_bool p q) = Init.Datatypes.true).

(* Why3 assumption *)
Definition null : addr := addr'mk 0%Z 0%Z.

(* Why3 assumption *)
Definition global (b:Numbers.BinNums.Z) : addr := addr'mk b 0%Z.

(* Why3 assumption *)
Definition shift (p:addr) (k:Numbers.BinNums.Z) : addr :=
  addr'mk (base p) ((offset p) + k)%Z.

(* Why3 assumption *)
Definition included (p:addr) (a:Numbers.BinNums.Z) (q:addr)
    (b:Numbers.BinNums.Z) : Prop :=
  (0%Z < a)%Z ->
  (0%Z <= b)%Z /\
  ((base p) = (base q)) /\
  ((offset q) <= (offset p))%Z /\
  (((offset p) + a)%Z <= ((offset q) + b)%Z)%Z.

(* Why3 assumption *)
Definition separated (p:addr) (a:Numbers.BinNums.Z) (q:addr)
    (b:Numbers.BinNums.Z) : Prop :=
  (a <= 0%Z)%Z \/
  (b <= 0%Z)%Z \/
  ~ ((base p) = (base q)) \/
  (((offset q) + b)%Z <= (offset p))%Z \/
  (((offset p) + a)%Z <= (offset q))%Z.

(* Why3 assumption *)
Definition eqmem {a:Type} {a_WT:WhyType a} (m1:addr -> a) (m2:addr -> a)
    (p:addr) (a1:Numbers.BinNums.Z) : Prop :=
  forall (q:addr), included q 1%Z p a1 -> ((m1 q) = (m2 q)).

Parameter havoc:
  forall {a:Type} {a_WT:WhyType a}, (addr -> a) -> (addr -> a) -> addr ->
  Numbers.BinNums.Z -> addr -> a.

(* Why3 assumption *)
Definition valid_rw (m:Numbers.BinNums.Z -> Numbers.BinNums.Z) (p:addr)
    (n:Numbers.BinNums.Z) : Prop :=
  (0%Z < n)%Z ->
  (0%Z < (base p))%Z /\
  (0%Z <= (offset p))%Z /\ (((offset p) + n)%Z <= (m (base p)))%Z.

(* Why3 assumption *)
Definition valid_rd (m:Numbers.BinNums.Z -> Numbers.BinNums.Z) (p:addr)
    (n:Numbers.BinNums.Z) : Prop :=
  (0%Z < n)%Z ->
  ~ (0%Z = (base p)) /\
  (0%Z <= (offset p))%Z /\ (((offset p) + n)%Z <= (m (base p)))%Z.

(* Why3 assumption *)
Definition valid_obj (m:Numbers.BinNums.Z -> Numbers.BinNums.Z) (p:addr)
    (n:Numbers.BinNums.Z) : Prop :=
  (0%Z < n)%Z ->
  (p = null) \/
  ~ (0%Z = (base p)) /\
  (0%Z <= (offset p))%Z /\ (((offset p) + n)%Z <= (1%Z + (m (base p)))%Z)%Z.

(* Why3 assumption *)
Definition invalid (m:Numbers.BinNums.Z -> Numbers.BinNums.Z) (p:addr)
    (n:Numbers.BinNums.Z) : Prop :=
  (n <= 0%Z)%Z \/
  ((base p) = 0%Z) \/
  ((m (base p)) <= (offset p))%Z \/ (((offset p) + n)%Z <= 0%Z)%Z.

Axiom valid_rw_rd :
  forall (m:Numbers.BinNums.Z -> Numbers.BinNums.Z), forall (p:addr),
  forall (n:Numbers.BinNums.Z), valid_rw m p n -> valid_rd m p n.

Axiom valid_string :
  forall (m:Numbers.BinNums.Z -> Numbers.BinNums.Z), forall (p:addr),
  ((base p) < 0%Z)%Z ->
  (0%Z <= (offset p))%Z /\ ((offset p) < (m (base p)))%Z ->
  valid_rd m p 1%Z /\ ~ valid_rw m p 1%Z.

Axiom separated_1 :
  forall (p:addr) (q:addr),
  forall (a:Numbers.BinNums.Z) (b:Numbers.BinNums.Z) (i:Numbers.BinNums.Z)
    (j:Numbers.BinNums.Z),
  separated p a q b -> ((offset p) <= i)%Z /\ (i < ((offset p) + a)%Z)%Z ->
  ((offset q) <= j)%Z /\ (j < ((offset q) + b)%Z)%Z ->
  ~ ((addr'mk (base p) i) = (addr'mk (base q) j)).

Parameter region: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter linked: (Numbers.BinNums.Z -> Numbers.BinNums.Z) -> Prop.

Parameter sconst: (addr -> Numbers.BinNums.Z) -> Prop.

(* Why3 assumption *)
Definition framed (m:addr -> addr) : Prop :=
  forall (p:addr), ((region (base p)) <= 0%Z)%Z ->
  ((region (base (m p))) <= 0%Z)%Z.

Axiom separated_included :
  forall (p:addr) (q:addr),
  forall (a:Numbers.BinNums.Z) (b:Numbers.BinNums.Z), (0%Z < a)%Z ->
  (0%Z < b)%Z -> separated p a q b -> ~ included p a q b.

Axiom included_trans :
  forall (p:addr) (q:addr) (r:addr),
  forall (a:Numbers.BinNums.Z) (b:Numbers.BinNums.Z) (c:Numbers.BinNums.Z),
  included p a q b -> included q b r c -> included p a r c.

Axiom separated_trans :
  forall (p:addr) (q:addr) (r:addr),
  forall (a:Numbers.BinNums.Z) (b:Numbers.BinNums.Z) (c:Numbers.BinNums.Z),
  included p a q b -> separated q b r c -> separated p a r c.

Axiom separated_sym :
  forall (p:addr) (q:addr),
  forall (a:Numbers.BinNums.Z) (b:Numbers.BinNums.Z),
  separated p a q b <-> separated q b p a.

Axiom eqmem_included :
  forall {a:Type} {a_WT:WhyType a},
  forall (m1:addr -> a) (m2:addr -> a), forall (p:addr) (q:addr),
  forall (a1:Numbers.BinNums.Z) (b:Numbers.BinNums.Z), included p a1 q b ->
  eqmem m1 m2 q b -> eqmem m1 m2 p a1.

Axiom eqmem_sym :
  forall {a:Type} {a_WT:WhyType a},
  forall (m1:addr -> a) (m2:addr -> a), forall (p:addr),
  forall (a1:Numbers.BinNums.Z), eqmem m1 m2 p a1 -> eqmem m2 m1 p a1.

Axiom havoc_access :
  forall {a:Type} {a_WT:WhyType a},
  forall (m0:addr -> a) (m1:addr -> a), forall (q:addr) (p:addr),
  forall (a1:Numbers.BinNums.Z),
  (separated q 1%Z p a1 -> ((havoc m0 m1 p a1 q) = (m1 q))) /\
  (~ separated q 1%Z p a1 -> ((havoc m0 m1 p a1 q) = (m0 q))).

Parameter cinits: (addr -> Init.Datatypes.bool) -> Prop.

(* Why3 assumption *)
Definition is_init_range (m:addr -> Init.Datatypes.bool) (p:addr)
    (l:Numbers.BinNums.Z) : Prop :=
  forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < l)%Z ->
  ((m (shift p i)) = Init.Datatypes.true).

Parameter set_init:
  (addr -> Init.Datatypes.bool) -> addr -> Numbers.BinNums.Z ->
  addr -> Init.Datatypes.bool.

Axiom set_init_access :
  forall (m:addr -> Init.Datatypes.bool), forall (q:addr) (p:addr),
  forall (a:Numbers.BinNums.Z),
  (separated q 1%Z p a -> ((set_init m p a q) = (m q))) /\
  (~ separated q 1%Z p a -> ((set_init m p a q) = Init.Datatypes.true)).

(* Why3 assumption *)
Definition monotonic_init (m1:addr -> Init.Datatypes.bool)
    (m2:addr -> Init.Datatypes.bool) : Prop :=
  forall (p:addr), ((m1 p) = Init.Datatypes.true) ->
  ((m2 p) = Init.Datatypes.true).

Parameter int_of_addr: addr -> Numbers.BinNums.Z.

Parameter addr_of_int: Numbers.BinNums.Z -> addr.

Axiom table : Type.
Parameter table_WhyType : WhyType table.
Existing Instance table_WhyType.

Parameter table_of_base: Numbers.BinNums.Z -> table.

Parameter table_to_offset: table -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom table_to_offset_zero :
  forall (t:table), ((table_to_offset t 0%Z) = 0%Z).

Axiom table_to_offset_monotonic :
  forall (t:table), forall (o1:Numbers.BinNums.Z) (o2:Numbers.BinNums.Z),
  (o1 <= o2)%Z <-> ((table_to_offset t o1) <= (table_to_offset t o2))%Z.

Axiom int_of_addr_bijection :
  forall (a:Numbers.BinNums.Z), ((int_of_addr (addr_of_int a)) = a).

Axiom addr_of_int_bijection :
  forall (p:addr), ((addr_of_int (int_of_addr p)) = p).

Axiom addr_of_null : ((int_of_addr null) = 0%Z).

(* Why3 assumption *)
Definition is_bool (x:Numbers.BinNums.Z) : Prop := (x = 0%Z) \/ (x = 1%Z).

(* Why3 assumption *)
Definition is_uint8 (x:Numbers.BinNums.Z) : Prop :=
  (0%Z <= x)%Z /\ (x < 256%Z)%Z.

(* Why3 assumption *)
Definition is_sint8 (x:Numbers.BinNums.Z) : Prop :=
  ((-128%Z)%Z <= x)%Z /\ (x < 128%Z)%Z.

(* Why3 assumption *)
Definition is_uint16 (x:Numbers.BinNums.Z) : Prop :=
  (0%Z <= x)%Z /\ (x < 65536%Z)%Z.

(* Why3 assumption *)
Definition is_sint16 (x:Numbers.BinNums.Z) : Prop :=
  ((-32768%Z)%Z <= x)%Z /\ (x < 32768%Z)%Z.

(* Why3 assumption *)
Definition is_uint32 (x:Numbers.BinNums.Z) : Prop :=
  (0%Z <= x)%Z /\ (x < 4294967296%Z)%Z.

(* Why3 assumption *)
Definition is_sint32 (x:Numbers.BinNums.Z) : Prop :=
  ((-2147483648%Z)%Z <= x)%Z /\ (x < 2147483648%Z)%Z.

(* Why3 assumption *)
Definition is_uint64 (x:Numbers.BinNums.Z) : Prop :=
  (0%Z <= x)%Z /\ (x < 18446744073709551616%Z)%Z.

(* Why3 assumption *)
Definition is_sint64 (x:Numbers.BinNums.Z) : Prop :=
  ((-9223372036854775808%Z)%Z <= x)%Z /\ (x < 9223372036854775808%Z)%Z.

Axiom is_bool0 : is_bool 0%Z.

Axiom is_bool1 : is_bool 1%Z.

Parameter to_bool: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom to_bool'def :
  forall (x:Numbers.BinNums.Z),
  ((x = 0%Z) -> ((to_bool x) = 0%Z)) /\ (~ (x = 0%Z) -> ((to_bool x) = 1%Z)).

Parameter to_uint8: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter to_sint8: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter to_uint16: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter to_sint16: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter to_uint32: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter to_sint32: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter to_uint64: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter to_sint64: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter two_power_abs: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom two_power_abs_is_positive :
  forall (n:Numbers.BinNums.Z), (0%Z < (two_power_abs n))%Z.

Axiom two_power_abs_plus_pos :
  forall (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z), (0%Z <= n)%Z ->
  (0%Z <= m)%Z ->
  ((two_power_abs (n + m)%Z) = ((two_power_abs n) * (two_power_abs m))%Z).

Axiom two_power_abs_plus_one :
  forall (n:Numbers.BinNums.Z), (0%Z <= n)%Z ->
  ((two_power_abs (n + 1%Z)%Z) = (2%Z * (two_power_abs n))%Z).

(* Why3 assumption *)
Definition is_uint (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) : Prop :=
  (0%Z <= x)%Z /\ (x < (two_power_abs n))%Z.

(* Why3 assumption *)
Definition is_sint (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) : Prop :=
  ((-(two_power_abs n))%Z <= x)%Z /\ (x < (two_power_abs n))%Z.

Parameter to_uint:
  Numbers.BinNums.Z -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter to_sint:
  Numbers.BinNums.Z -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom is_to_uint :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z), is_uint n (to_uint n x).

Axiom is_to_sint :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z), is_sint n (to_sint n x).

Axiom is_to_uint8 : forall (x:Numbers.BinNums.Z), is_uint8 (to_uint8 x).

Axiom is_to_sint8 : forall (x:Numbers.BinNums.Z), is_sint8 (to_sint8 x).

Axiom is_to_uint16 : forall (x:Numbers.BinNums.Z), is_uint16 (to_uint16 x).

Axiom is_to_sint16 : forall (x:Numbers.BinNums.Z), is_sint16 (to_sint16 x).

Axiom is_to_uint32 : forall (x:Numbers.BinNums.Z), is_uint32 (to_uint32 x).

Axiom is_to_sint32 : forall (x:Numbers.BinNums.Z), is_sint32 (to_sint32 x).

Axiom is_to_uint64 : forall (x:Numbers.BinNums.Z), is_uint64 (to_uint64 x).

Axiom is_to_sint64 : forall (x:Numbers.BinNums.Z), is_sint64 (to_sint64 x).

Axiom id_uint :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z),
  is_uint n x <-> ((to_uint n x) = x).

Axiom id_sint :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z),
  is_sint n x <-> ((to_sint n x) = x).

Axiom id_uint8 :
  forall (x:Numbers.BinNums.Z), is_uint8 x -> ((to_uint8 x) = x).

Axiom id_sint8 :
  forall (x:Numbers.BinNums.Z), is_sint8 x -> ((to_sint8 x) = x).

Axiom id_uint16 :
  forall (x:Numbers.BinNums.Z), is_uint16 x -> ((to_uint16 x) = x).

Axiom id_sint16 :
  forall (x:Numbers.BinNums.Z), is_sint16 x -> ((to_sint16 x) = x).

Axiom id_uint32 :
  forall (x:Numbers.BinNums.Z), is_uint32 x -> ((to_uint32 x) = x).

Axiom id_sint32 :
  forall (x:Numbers.BinNums.Z), is_sint32 x -> ((to_sint32 x) = x).

Axiom id_uint64 :
  forall (x:Numbers.BinNums.Z), is_uint64 x -> ((to_uint64 x) = x).

Axiom id_sint64 :
  forall (x:Numbers.BinNums.Z), is_sint64 x -> ((to_sint64 x) = x).

Axiom proj_uint :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z),
  ((to_uint n (to_uint n x)) = (to_uint n x)).

Axiom proj_sint :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z),
  ((to_sint n (to_sint n x)) = (to_sint n x)).

Axiom proj_uint8 :
  forall (x:Numbers.BinNums.Z), ((to_uint8 (to_uint8 x)) = (to_uint8 x)).

Axiom proj_sint8 :
  forall (x:Numbers.BinNums.Z), ((to_sint8 (to_sint8 x)) = (to_sint8 x)).

Axiom proj_uint16 :
  forall (x:Numbers.BinNums.Z), ((to_uint16 (to_uint16 x)) = (to_uint16 x)).

Axiom proj_sint16 :
  forall (x:Numbers.BinNums.Z), ((to_sint16 (to_sint16 x)) = (to_sint16 x)).

Axiom proj_uint32 :
  forall (x:Numbers.BinNums.Z), ((to_uint32 (to_uint32 x)) = (to_uint32 x)).

Axiom proj_sint32 :
  forall (x:Numbers.BinNums.Z), ((to_sint32 (to_sint32 x)) = (to_sint32 x)).

Axiom proj_uint64 :
  forall (x:Numbers.BinNums.Z), ((to_uint64 (to_uint64 x)) = (to_uint64 x)).

Axiom proj_sint64 :
  forall (x:Numbers.BinNums.Z), ((to_sint64 (to_sint64 x)) = (to_sint64 x)).

Axiom proj_su :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z),
  ((to_sint n (to_uint n x)) = (to_uint n x)).

Axiom incl_su :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z), is_uint n x ->
  is_sint n x.

Axiom proj_su_uint :
  forall (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z) (x:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z ->
  ((to_sint (m + n)%Z (to_uint n x)) = (to_uint n x)).

Axiom proj_su_sint :
  forall (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z) (x:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z ->
  ((to_sint n (to_uint (m + (n + 1%Z)%Z)%Z x)) = (to_sint n x)).

Axiom proj_int8 :
  forall (x:Numbers.BinNums.Z), ((to_sint8 (to_uint8 x)) = (to_sint8 x)).

Axiom proj_int16 :
  forall (x:Numbers.BinNums.Z), ((to_sint16 (to_uint16 x)) = (to_sint16 x)).

Axiom proj_int32 :
  forall (x:Numbers.BinNums.Z), ((to_sint32 (to_uint32 x)) = (to_sint32 x)).

Axiom proj_int64 :
  forall (x:Numbers.BinNums.Z), ((to_sint64 (to_uint64 x)) = (to_sint64 x)).

Axiom proj_us_uint :
  forall (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z) (x:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z ->
  ((to_uint (n + 1%Z)%Z (to_sint (m + n)%Z x)) = (to_uint (n + 1%Z)%Z x)).

Axiom incl_uint :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= i)%Z -> is_uint n x -> is_uint (n + i)%Z x.

Axiom incl_sint :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= i)%Z -> is_sint n x -> is_sint (n + i)%Z x.

Axiom incl_int :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= i)%Z -> is_uint n x -> is_sint (n + i)%Z x.

Parameter bit_testb:
  Numbers.BinNums.Z -> Numbers.BinNums.Z -> Init.Datatypes.bool.

Parameter bit_test: Numbers.BinNums.Z -> Numbers.BinNums.Z -> Prop.

Parameter lnot: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter land: Numbers.BinNums.Z -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter lxor: Numbers.BinNums.Z -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter lor: Numbers.BinNums.Z -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter lsl: Numbers.BinNums.Z -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Parameter lsr: Numbers.BinNums.Z -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom lnot_bool : ((lnot 0%Z) = (-1%Z)%Z) /\ ((lnot (-1%Z)%Z) = 0%Z).

Axiom land_idemp : forall (x:Numbers.BinNums.Z), ((land x x) = x).

Axiom land_idemp_bis :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((land x (land x y)) = (land x y)).

Axiom land_0 : forall (x:Numbers.BinNums.Z), ((land 0%Z x) = 0%Z).

Axiom land_0bis : forall (x:Numbers.BinNums.Z), ((land x 0%Z) = 0%Z).

Axiom land_1 : forall (x:Numbers.BinNums.Z), ((land (-1%Z)%Z x) = x).

Axiom land_1bis : forall (x:Numbers.BinNums.Z), ((land x (-1%Z)%Z) = x).

Axiom land_bool :
  ((land 0%Z 0%Z) = 0%Z) /\
  ((land 0%Z 1%Z) = 0%Z) /\ ((land 1%Z 0%Z) = 0%Z) /\ ((land 1%Z 1%Z) = 1%Z).

Axiom lor_idemp : forall (x:Numbers.BinNums.Z), ((lor x x) = x).

Axiom lor_idemp_bis :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((lor x (lor x y)) = (lor x y)).

Axiom lor_1 : forall (x:Numbers.BinNums.Z), ((lor (-1%Z)%Z x) = (-1%Z)%Z).

Axiom lor_1bis : forall (x:Numbers.BinNums.Z), ((lor x (-1%Z)%Z) = (-1%Z)%Z).

Axiom lor_0 : forall (x:Numbers.BinNums.Z), ((lor 0%Z x) = x).

Axiom lor_0bis : forall (x:Numbers.BinNums.Z), ((lor x 0%Z) = x).

Axiom lor_bool :
  ((lor 0%Z 0%Z) = 0%Z) /\
  ((lor 0%Z 1%Z) = 1%Z) /\ ((lor 1%Z 0%Z) = 1%Z) /\ ((lor 1%Z 1%Z) = 1%Z).

Axiom lxor_nilpotent : forall (x:Numbers.BinNums.Z), ((lxor x x) = 0%Z).

Axiom lxor_nilpotent_bis :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((lxor x (lxor x y)) = y).

Axiom lxor_1 : forall (x:Numbers.BinNums.Z), ((lxor (-1%Z)%Z x) = (lnot x)).

Axiom lxor_1bis :
  forall (x:Numbers.BinNums.Z), ((lxor x (-1%Z)%Z) = (lnot x)).

Axiom lxor_0 : forall (x:Numbers.BinNums.Z), ((lxor 0%Z x) = x).

Axiom lxor_0bis : forall (x:Numbers.BinNums.Z), ((lxor x 0%Z) = x).

Axiom lxor_bool :
  ((lxor 0%Z 0%Z) = 0%Z) /\
  ((lxor 0%Z 1%Z) = 1%Z) /\ ((lxor 1%Z 0%Z) = 1%Z) /\ ((lxor 1%Z 1%Z) = 0%Z).

Axiom lsl_0 : forall (x:Numbers.BinNums.Z), ((lsl x 0%Z) = x).

Axiom lsl_1 : forall (x:Numbers.BinNums.Z), ((lsl x 1%Z) = (2%Z * x)%Z).

Axiom lsl_add :
  forall (x:Numbers.BinNums.Z) (p:Numbers.BinNums.Z) (q:Numbers.BinNums.Z),
  (0%Z <= p)%Z -> (0%Z <= q)%Z -> ((lsl (lsl x p) q) = (lsl x (p + q)%Z)).

Axiom lsr_0 : forall (x:Numbers.BinNums.Z), ((lsr x 0%Z) = x).

Axiom lsr_1 :
  forall (x:Numbers.BinNums.Z), (0%Z <= x)%Z ->
  ((lsr x 1%Z) = (ZArith.BinInt.Z.quot x 2%Z)).

Axiom lsr_add :
  forall (x:Numbers.BinNums.Z) (p:Numbers.BinNums.Z) (q:Numbers.BinNums.Z),
  (0%Z <= p)%Z -> (0%Z <= q)%Z -> ((lsr (lsr x p) q) = (lsr x (p + q)%Z)).

Axiom lsl_lsr_add :
  forall (x:Numbers.BinNums.Z) (p:Numbers.BinNums.Z) (q:Numbers.BinNums.Z),
  (0%Z <= q)%Z /\ (q <= p)%Z -> ((lsr (lsl x p) q) = (lsl x (p - q)%Z)).

Axiom bit_test_def :
  forall (x:Numbers.BinNums.Z) (k:Numbers.BinNums.Z),
  ((bit_testb x k) = Init.Datatypes.true) <-> bit_test x k.

Axiom bit_test_extraction :
  forall (x:Numbers.BinNums.Z) (k:Numbers.BinNums.Z), (0%Z <= k)%Z ->
  ~ ((land x (lsl 1%Z k)) = 0%Z) <-> bit_test x k.

Axiom bit_test_extraction_eq :
  forall (x:Numbers.BinNums.Z) (k:Numbers.BinNums.Z), (0%Z <= k)%Z ->
  ((land x (lsl 1%Z k)) = (lsl 1%Z k)) <-> bit_test x k.

Axiom lsl_1_0 : ((lsl 1%Z 0%Z) = 1%Z).

Axiom bit_test_extraction_bis :
  forall (x:Numbers.BinNums.Z), ~ ((land 1%Z x) = 0%Z) -> bit_test x 0%Z.

Axiom bit_test_extraction_bis_eq :
  forall (x:Numbers.BinNums.Z), bit_test x 0%Z -> ((land 1%Z x) = 1%Z).

Axiom lnot_extraction_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (0%Z <= i)%Z ->
  ((bit_testb (lnot x) i) = (Init.Datatypes.negb (bit_testb x i))).

Axiom lnot_extraction :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (0%Z <= i)%Z ->
  bit_test (lnot x) i <-> ~ bit_test x i.

Axiom land_extraction_bool :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z ->
  ((bit_testb (land x y) i) =
   (Init.Datatypes.andb (bit_testb x i) (bit_testb y i))).

Axiom land_extraction :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z -> bit_test (land x y) i <-> bit_test x i /\ bit_test y i.

Axiom lor_extraction_bool :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z ->
  ((bit_testb (lor x y) i) =
   (Init.Datatypes.orb (bit_testb x i) (bit_testb y i))).

Axiom lor_extraction :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z -> bit_test (lor x y) i <-> bit_test x i \/ bit_test y i.

Axiom lxor_extraction_bool :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z ->
  ((bit_testb (lxor x y) i) =
   (Init.Datatypes.xorb (bit_testb x i) (bit_testb y i))).

Axiom lxor_extraction :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z -> bit_test (lxor x y) i <-> (bit_test x i <-> ~ bit_test y i).

Axiom lsl_1_two_power :
  forall (n:Numbers.BinNums.Z), (0%Z <= n)%Z ->
  ((lsl 1%Z n) = (two_power_abs n)).

Axiom land_1_lsl_1 :
  forall (a:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (n:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (a < (lsl 1%Z n))%Z ->
  (((2%Z * a)%Z + (land 1%Z x))%Z < (lsl 1%Z (1%Z + n)%Z))%Z.

Axiom lsl_extraction_sup_bool :
  forall (x:Numbers.BinNums.Z) (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z -> (n <= m)%Z ->
  ((bit_testb (lsl x n) m) = (bit_testb x (m - n)%Z)).

Axiom lsl_extraction_sup :
  forall (x:Numbers.BinNums.Z) (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z -> (n <= m)%Z ->
  bit_test (lsl x n) m <-> bit_test x (m - n)%Z.

Axiom lsl_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z -> (m < n)%Z ->
  ((bit_testb (lsl x n) m) = Init.Datatypes.false).

Axiom lsl_extraction_inf :
  forall (x:Numbers.BinNums.Z) (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z -> (m < n)%Z -> ~ bit_test (lsl x n) m.

Axiom lsr_extraction_bool :
  forall (x:Numbers.BinNums.Z) (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z ->
  ((bit_testb (lsr x n) m) = (bit_testb x (m + n)%Z)).

Axiom lsr_extractionl :
  forall (x:Numbers.BinNums.Z) (n:Numbers.BinNums.Z) (m:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> (0%Z <= m)%Z ->
  bit_test (lsr x n) m <-> bit_test x (m + n)%Z.

Axiom lsl1_extraction_bool :
  forall (i:Numbers.BinNums.Z) (j:Numbers.BinNums.Z), (0%Z <= i)%Z ->
  (0%Z <= j)%Z -> ((bit_testb (lsl 1%Z i) j) = (eqb i j)).

Axiom lsl1_extraction :
  forall (i:Numbers.BinNums.Z) (j:Numbers.BinNums.Z), (0%Z <= i)%Z ->
  (0%Z <= j)%Z -> bit_test (lsl 1%Z i) j <-> (i = j).

Axiom pos_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z) (j:Numbers.BinNums.Z),
  (0%Z <= x)%Z -> (0%Z <= i)%Z -> (x < (lsl 1%Z i))%Z -> (i <= j)%Z ->
  ~ bit_test x j.

Axiom pos_extraction_sup_inv :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (0%Z <= i)%Z ->
  (forall (j:Numbers.BinNums.Z), (i <= j)%Z -> ~ bit_test x j) ->
  (0%Z <= x)%Z /\ (x < (lsl 1%Z i))%Z.

Axiom to_uint_extraction_sup :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n <= i)%Z -> is_uint n x -> ~ bit_test x i.

Axiom to_uint_extraction_inf_bool :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < n)%Z ->
  ((bit_testb (to_uint n x) i) = (bit_testb x i)).

Axiom to_uint_extraction_inf :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < n)%Z -> bit_test (to_uint n x) i <-> bit_test x i.

Axiom is_uint_ext :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> is_uint n x -> is_uint n y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < n)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_uint8_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (8%Z <= i)%Z ->
  is_uint8 x -> ~ bit_test x i.

Axiom to_uint8_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 8%Z)%Z ->
  ((bit_testb (to_uint8 x) i) = (bit_testb x i)).

Axiom to_uint8_extraction_inf :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 8%Z)%Z -> bit_test (to_uint8 x) i <-> bit_test x i.

Axiom is_uint8_ext :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint8 x ->
  is_uint8 y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < 8%Z)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_uint16_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (16%Z <= i)%Z ->
  is_uint16 x -> ~ bit_test x i.

Axiom to_uint16_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 16%Z)%Z ->
  ((bit_testb (to_uint16 x) i) = (bit_testb x i)).

Axiom to_uint16_extraction_inf :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 16%Z)%Z -> bit_test (to_uint16 x) i <-> bit_test x i.

Axiom is_uint16_ext :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint16 x ->
  is_uint16 y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < 16%Z)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_uint32_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (32%Z <= i)%Z ->
  is_uint32 x -> ~ bit_test x i.

Axiom to_uint32_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 32%Z)%Z ->
  ((bit_testb (to_uint32 x) i) = (bit_testb x i)).

Axiom to_uint32_extraction_inf :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 32%Z)%Z -> bit_test (to_uint32 x) i <-> bit_test x i.

Axiom is_uint32_ext :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint32 x ->
  is_uint32 y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < 32%Z)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_uint64_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (64%Z <= i)%Z ->
  is_uint64 x -> ~ bit_test x i.

Axiom to_uint64_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 64%Z)%Z ->
  ((bit_testb (to_uint64 x) i) = (bit_testb x i)).

Axiom to_uint64_extraction_inf :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 64%Z)%Z -> bit_test (to_uint64 x) i <-> bit_test x i.

Axiom is_uint64_ext :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint64 x ->
  is_uint64 y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < 64%Z)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_sint_extraction_sup :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n <= i)%Z -> is_sint n x -> bit_test x i <-> (x < 0%Z)%Z.

Axiom to_sint_extraction_inf_bool :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < n)%Z ->
  ((bit_testb (to_sint n x) i) = (bit_testb x i)).

Axiom to_sint_extraction_inf :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < n)%Z -> bit_test (to_sint n x) i <-> bit_test x i.

Axiom is_sint_ext :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  (0%Z <= n)%Z -> is_sint n x -> is_sint n y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i <= n)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_sint8_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (7%Z <= i)%Z ->
  is_sint8 x -> bit_test x i <-> (x < 0%Z)%Z.

Axiom to_sint8_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 7%Z)%Z ->
  ((bit_testb (to_sint8 x) i) = (bit_testb x i)).

Axiom to_sint8_extraction_inf :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 7%Z)%Z -> bit_test (to_sint8 x) i <-> bit_test x i.

Axiom is_sint8_ext :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint8 x ->
  is_sint8 y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i <= 7%Z)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_sint16_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (15%Z <= i)%Z ->
  is_sint16 x -> bit_test x i <-> (x < 0%Z)%Z.

Axiom to_sint16_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 15%Z)%Z ->
  ((bit_testb (to_sint16 x) i) = (bit_testb x i)).

Axiom to_sint16_extraction_inf :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 15%Z)%Z -> bit_test (to_sint16 x) i <-> bit_test x i.

Axiom is_sint16_ext :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint16 x ->
  is_sint16 y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i <= 15%Z)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_sint32_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (31%Z <= i)%Z ->
  is_sint32 x -> bit_test x i <-> (x < 0%Z)%Z.

Axiom to_sint32_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 31%Z)%Z ->
  ((bit_testb (to_sint32 x) i) = (bit_testb x i)).

Axiom to_sint32_extraction_inf :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 31%Z)%Z -> bit_test (to_sint32 x) i <-> bit_test x i.

Axiom is_sint32_ext :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint32 x ->
  is_sint32 y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i <= 31%Z)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_sint64_extraction_sup :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z), (63%Z <= i)%Z ->
  is_sint64 x -> bit_test x i <-> (x < 0%Z)%Z.

Axiom to_sint64_extraction_inf_bool :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 63%Z)%Z ->
  ((bit_testb (to_sint64 x) i) = (bit_testb x i)).

Axiom to_sint64_extraction_inf :
  forall (x:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 63%Z)%Z -> bit_test (to_sint64 x) i <-> bit_test x i.

Axiom is_sint64_ext :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint64 x ->
  is_sint64 y ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i <= 63%Z)%Z ->
   bit_test x i <-> bit_test y i) ->
  (x = y).

Axiom to_uint_lor :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((to_uint n (lor x y)) = (lor (to_uint n x) (to_uint n y))).

Axiom to_uint8_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((to_uint8 (lor x y)) = (lor (to_uint8 x) (to_uint 8%Z y))).

Axiom to_uint16_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((to_uint16 (lor x y)) = (lor (to_uint16 x) (to_uint16 y))).

Axiom to_uint32_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((to_uint32 (lor x y)) = (lor (to_uint32 x) (to_uint32 y))).

Axiom to_uint64_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  ((to_uint64 (lor x y)) = (lor (to_uint64 x) (to_uint64 y))).

Axiom is_uint_lxor :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  is_uint n x -> is_uint n y -> ((to_uint n (lxor x y)) = (lxor x y)).

Axiom is_uint_lor :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  is_uint n x -> is_uint n y -> ((to_uint n (lor x y)) = (lor x y)).

Axiom is_uint_land :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  is_uint n x -> is_uint n y -> ((to_uint n (land x y)) = (land x y)).

Axiom is_uint_lsr :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  (0%Z <= y)%Z -> is_uint n x -> ((to_uint n (lsr x y)) = (lsr x y)).

Axiom is_uint_lsl1_inf :
  forall (n:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  (0%Z <= y)%Z /\ (y < n)%Z -> ((to_uint n (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_uint_lsl1_sup :
  forall (n:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n <= y)%Z -> ((to_uint n (lsl 1%Z y)) = 0%Z).

Axiom is_uint8_lxor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint8 x ->
  is_uint8 y -> ((to_uint8 (lxor x y)) = (lxor x y)).

Axiom is_uint8_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint8 x ->
  is_uint8 y -> ((to_uint8 (lor x y)) = (lor x y)).

Axiom is_uint8_land :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint8 x ->
  is_uint8 y -> ((to_uint8 (land x y)) = (land x y)).

Axiom is_uint8_lsr :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= y)%Z ->
  is_uint8 x -> ((to_uint8 (lsr x y)) = (lsr x y)).

Axiom is_uint8_lsl1_inf :
  forall (y:Numbers.BinNums.Z), (0%Z <= y)%Z /\ (y < 8%Z)%Z ->
  ((to_uint8 (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_uint8_lsl1_sup :
  forall (y:Numbers.BinNums.Z), (8%Z <= y)%Z ->
  ((to_uint8 (lsl 1%Z y)) = 0%Z).

Axiom is_uint16_lxor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint16 x ->
  is_uint16 y -> ((to_uint16 (lxor x y)) = (lxor x y)).

Axiom is_uint16_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint16 x ->
  is_uint16 y -> ((to_uint16 (lor x y)) = (lor x y)).

Axiom is_uint16_land :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint16 x ->
  is_uint16 y -> ((to_uint16 (land x y)) = (land x y)).

Axiom is_uint16_lsr :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= y)%Z ->
  is_uint16 x -> ((to_uint16 (lsr x y)) = (lsr x y)).

Axiom is_uint16_lsl1_inf :
  forall (y:Numbers.BinNums.Z), (0%Z <= y)%Z /\ (y < 16%Z)%Z ->
  ((to_uint16 (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_uint16_lsl1_sup :
  forall (y:Numbers.BinNums.Z), (16%Z <= y)%Z ->
  ((to_uint16 (lsl 1%Z y)) = 0%Z).

Axiom is_uint32_lxor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint32 x ->
  is_uint32 y -> ((to_uint32 (lxor x y)) = (lxor x y)).

Axiom is_uint32_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint32 x ->
  is_uint32 y -> ((to_uint32 (lor x y)) = (lor x y)).

Axiom is_uint32_land :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint32 x ->
  is_uint32 y -> ((to_uint32 (land x y)) = (land x y)).

Axiom is_uint32_lsr :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= y)%Z ->
  is_uint32 x -> ((to_uint32 (lsr x y)) = (lsr x y)).

Axiom is_uint32_lsl1_inf :
  forall (y:Numbers.BinNums.Z), (0%Z <= y)%Z /\ (y < 32%Z)%Z ->
  ((to_uint32 (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_uint32_lsl1_sup :
  forall (y:Numbers.BinNums.Z), (32%Z <= y)%Z ->
  ((to_uint32 (lsl 1%Z y)) = 0%Z).

Axiom is_uint64_lxor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint64 x ->
  is_uint64 y -> ((to_uint64 (lxor x y)) = (lxor x y)).

Axiom is_uint64_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint64 x ->
  is_uint64 y -> ((to_uint64 (lor x y)) = (lor x y)).

Axiom is_uint64_land :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_uint64 x ->
  is_uint64 y -> ((to_uint64 (land x y)) = (land x y)).

Axiom is_uint64_lsr :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= y)%Z ->
  is_uint64 x -> ((to_uint64 (lsr x y)) = (lsr x y)).

Axiom is_uint64_lsl1_inf :
  forall (y:Numbers.BinNums.Z), (0%Z <= y)%Z /\ (y < 64%Z)%Z ->
  ((to_uint64 (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_uint64_lsl1_sup :
  forall (y:Numbers.BinNums.Z), (64%Z <= y)%Z ->
  ((to_uint64 (lsl 1%Z y)) = 0%Z).

Axiom is_sint_lnot :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z), is_sint n x ->
  ((to_sint n (lnot x)) = (lnot x)).

Axiom is_sint_lxor :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  is_sint n x -> is_sint n y -> ((to_sint n (lxor x y)) = (lxor x y)).

Axiom is_sint_lor :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  is_sint n x -> is_sint n y -> ((to_sint n (lor x y)) = (lor x y)).

Axiom is_sint_land :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  is_sint n x -> is_sint n y -> ((to_sint n (land x y)) = (land x y)).

Axiom is_sint_lsr :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  (0%Z <= y)%Z -> is_sint n x -> ((to_sint n (lsr x y)) = (lsr x y)).

Axiom is_sint_lsl1_inf :
  forall (n:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  (0%Z <= y)%Z /\ (y < n)%Z -> ((to_sint n (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_sint_lsl1_sup :
  forall (n:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n < y)%Z -> ((to_sint n (lsl 1%Z y)) = 0%Z).

Axiom is_sint8_lnot :
  forall (x:Numbers.BinNums.Z), is_sint8 x ->
  ((to_sint8 (lnot x)) = (lnot x)).

Axiom is_sint8_lxor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint8 x ->
  is_sint8 y -> ((to_sint8 (lxor x y)) = (lxor x y)).

Axiom is_sint8_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint8 x ->
  is_sint8 y -> ((to_sint8 (lor x y)) = (lor x y)).

Axiom is_sint8_land :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint8 x ->
  is_sint8 y -> ((to_sint8 (land x y)) = (land x y)).

Axiom is_sint8_lsr :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= y)%Z ->
  is_sint8 x -> ((to_sint8 (lsr x y)) = (lsr x y)).

Axiom is_sint8_lsl1 : ((lsl 1%Z 7%Z) = 128%Z).

Axiom is_sint8_lsl1_inf :
  forall (y:Numbers.BinNums.Z), (0%Z <= y)%Z /\ (y < 7%Z)%Z ->
  ((to_sint8 (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_sint8_lsl1_sup :
  forall (y:Numbers.BinNums.Z), (8%Z <= y)%Z ->
  ((to_sint8 (lsl 1%Z y)) = 0%Z).

Axiom is_sint16_lnot :
  forall (x:Numbers.BinNums.Z), is_sint16 x ->
  ((to_sint16 (lnot x)) = (lnot x)).

Axiom is_sint16_lxor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint16 x ->
  is_sint16 y -> ((to_sint16 (lxor x y)) = (lxor x y)).

Axiom is_sint16_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint16 x ->
  is_sint16 y -> ((to_sint16 (lor x y)) = (lor x y)).

Axiom is_sint16_land :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint16 x ->
  is_sint16 y -> ((to_sint16 (land x y)) = (land x y)).

Axiom is_sint16_lsr :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= y)%Z ->
  is_sint16 x -> ((to_sint16 (lsr x y)) = (lsr x y)).

Axiom is_sint16_lsl1 : ((lsl 1%Z 15%Z) = 32768%Z).

Axiom is_sint16_lsl1_inf :
  forall (y:Numbers.BinNums.Z), (0%Z <= y)%Z /\ (y < 15%Z)%Z ->
  ((to_sint16 (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_sint16_lsl1_sup :
  forall (y:Numbers.BinNums.Z), (16%Z <= y)%Z ->
  ((to_sint16 (lsl 1%Z y)) = 0%Z).

Axiom is_sint32_lnot :
  forall (x:Numbers.BinNums.Z), is_sint32 x ->
  ((to_sint32 (lnot x)) = (lnot x)).

Axiom is_sint32_lxor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint32 x ->
  is_sint32 y -> ((to_sint32 (lxor x y)) = (lxor x y)).

Axiom is_sint32_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint32 x ->
  is_sint32 y -> ((to_sint32 (lor x y)) = (lor x y)).

Axiom is_sint32_land :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint32 x ->
  is_sint32 y -> ((to_sint32 (land x y)) = (land x y)).

Axiom is_sint32_lsr :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= y)%Z ->
  is_sint32 x -> ((to_sint32 (lsr x y)) = (lsr x y)).

Axiom is_sint32_lsl1 : ((lsl 1%Z 31%Z) = 2147483648%Z).

Axiom is_sint32_lsl1_inf :
  forall (y:Numbers.BinNums.Z), (0%Z <= y)%Z /\ (y < 31%Z)%Z ->
  ((to_sint32 (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_sint32_lsl1_sup :
  forall (y:Numbers.BinNums.Z), (32%Z <= y)%Z ->
  ((to_sint32 (lsl 1%Z y)) = 0%Z).

Axiom is_sint64_lnot :
  forall (x:Numbers.BinNums.Z), is_sint64 x ->
  ((to_sint64 (lnot x)) = (lnot x)).

Axiom is_sint64_lxor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint64 x ->
  is_sint64 y -> ((to_sint64 (lxor x y)) = (lxor x y)).

Axiom is_sint64_lor :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint64 x ->
  is_sint64 y -> ((to_sint64 (lor x y)) = (lor x y)).

Axiom is_sint64_land :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), is_sint64 x ->
  is_sint64 y -> ((to_sint64 (land x y)) = (land x y)).

Axiom is_sint64_lsr :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= y)%Z ->
  is_sint64 x -> ((to_sint64 (lsr x y)) = (lsr x y)).

Axiom is_sint64_lsl1 : ((lsl 1%Z 63%Z) = 9223372036854775808%Z).

Axiom is_sint64_lsl1_inf :
  forall (y:Numbers.BinNums.Z), (0%Z <= y)%Z /\ (y < 63%Z)%Z ->
  ((to_sint64 (lsl 1%Z y)) = (lsl 1%Z y)).

Axiom is_sint64_lsl1_sup :
  forall (y:Numbers.BinNums.Z), (64%Z <= y)%Z ->
  ((to_sint64 (lsl 1%Z y)) = 0%Z).

Axiom uint_land_range :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (0%Z <= x)%Z ->
  (0%Z <= (land x y))%Z /\ ((land x y) <= x)%Z.

Axiom uint_lor_inf :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), ((-1%Z)%Z <= x)%Z ->
  (0%Z <= y)%Z -> (x <= (lor x y))%Z.

Axiom sint_land_inf :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (x <= 0%Z)%Z ->
  (y < 0%Z)%Z -> ((land x y) <= x)%Z.

Axiom sint_lor_range :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), (x < 0%Z)%Z ->
  (x <= (lor x y))%Z /\ ((lor x y) < 0%Z)%Z.

Axiom is_uint_lor_distrib :
  forall (n:Numbers.BinNums.Z) (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z),
  is_uint n (lor x y) <-> is_uint n x /\ is_uint n y.

Axiom lor_addition :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), ((land x y) = 0%Z) ->
  ((x + y)%Z = (lor x y)).

Axiom lxor_addition :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), ((land x y) = 0%Z) ->
  ((x + y)%Z = (lxor x y)).

Axiom to_uint_land_edge :
  forall (x:Numbers.BinNums.Z) (n:Numbers.BinNums.Z), (0%Z <= n)%Z ->
  ((to_uint n x) = (land ((lsl 1%Z n) - 1%Z)%Z x)).

(* Why3 goal *)
Theorem wp_goal :
  forall (t:Numbers.BinNums.Z -> Numbers.BinNums.Z) (i:Numbers.BinNums.Z)
    (i1:Numbers.BinNums.Z) (a:addr) (a1:addr),
  let x := ZArith.BinInt.Z.rem (28865%Z * i1)%Z 65536%Z in
  let x1 := (3777%Z * i1)%Z in
  let x2 := (7681%Z * x)%Z in
  ~ (a1 = a) -> ((region (base a1)) <= 0%Z)%Z ->
  ((region (base a)) <= 0%Z)%Z -> ((-568568%Z)%Z <= i1)%Z ->
  ((-74397%Z)%Z <= i1)%Z -> ((-4095%Z)%Z <= i1)%Z -> ((-4095%Z)%Z <= i)%Z ->
  (i1 <= 4095%Z)%Z -> (i <= 4095%Z)%Z -> (i1 <= 74397%Z)%Z ->
  (i1 <= 568568%Z)%Z -> ((-279583%Z)%Z <= x)%Z -> (x <= 279583%Z)%Z ->
  linked t -> is_sint32 i1 -> is_sint32 i -> is_sint32 x1 ->
  valid_rw t a1 1%Z -> valid_rw t a 1%Z -> is_sint32 x ->
  is_sint32 (lsr x1 16%Z) -> is_sint32 x2 ->
  ((ZArith.BinInt.Z.rem x2 65536%Z) = (ZArith.BinInt.Z.rem x1 65536%Z)).
(* Why3 intros t i i1 a a1 x x1 x2 h1 h2 h3 h4 h5 h6 h7 h8 h9 h10 h11 h12 h13
        h14 h15 h16 h17 h18 h19 h20 h21 h22. *)
Proof.
  (* ** ->-Introduction (ND) **        ** ∀-Introduction (ND) **
   *
   *        Γ, A |- B                       Γ |- A[y/x]
   *    -----------------                ----------------
   *       Γ |- A -> B                       Γ |- ∀xA
   *
   *
   * ** Prod-Prop (CIC) **
   *
   * E[Γ] |- A : S     s∈S     E[Γ::(a : A)] |- B : Prop
   * ----------------------------------------------------
   *             E[Γ] |- ∀ a : A, B : Prop
   *
   * ** Let (CIC) ***
   *
   *     E[Γ] |- t1 : A     E[Γ::(x := t1 : A)] |- t2 : B
   * ---------------------------------------------------------
   *          E[Γ] |- let x := t1 : A in t2 : B[t1/x]
   *)
  intros t i i1 a a1 x x1 x2 h1 h2 h3 h4 h5 h6
         h7 h8 h9 h10 h11 h12 h13 h14 h15 h16
         h17 h18 h19 h20 h21 h22.
  clear h22 h21 h20 h19 h18 h17 h16 h15 h14 h13 h12
        h11 h10 h9 h8 h7 h6 h5 h4 h3 h2 h1 a1 a t.
  unfold x2; clear x2. subst x1 x.
  rename i1 into f128.

  Print int.
  Print Z.
  Print positive.
  (*
   * Coq uses two's complement encoding for integers.
   * - Z0 = 0
   * - Zpos p is a positive integer
   * - Zneg p is a negative integer
   *
   * Let p be a Coq positive and |p| be the integer value of p.
   * - tobin(xH)   = 1
   * - tobin(xO p) = tobin(p)0, |xO p| = |p| * 2
   * - tobin(xI p) = tobin(p)1, |xI p| = |p| * 2 + 1
   *)

  (*
   *   (P * ((ZETA_PINV * f128) % (1 << 16))) % (1 << 16)
   * = (7681 * ((28865 * f128) % 65536)) % 65536
   *)
  Search Z.rem.
  Search (Z.rem (_ * Z.rem _ ?n) ?n).
  rewrite Zquot.Zmult_rem_idemp_r.
  (*
   * = (7681 * (28865 * f128)) % 65536     # (a * (b%n))%n = (a * b)%n
   *)

  Search (_ * (_ * _) = (_ * _) * _)%Z.
  rewrite Z.mul_assoc.
  (*
   * = ((7681 * 28865) * f128) % 65536     # a * (b * c) = (a * b) * c
   *)

  Check Zquot.Zmult_rem_idemp_l.
  rewrite <- Zquot.Zmult_rem_idemp_l.
  (*
   * = ((7681 * 28865) % 65536 * f128) % 65536  # ((a%n) * b)%n = (a * b)%n
   * = (3777 * f128) % 65536
   * = (ZETA * f128) % (1 << 16)
   *)

  reflexivity.
Qed.

