#include <limits.h>

/*@
  @ requires INT_MIN <= x * y <= INT_MAX;
  @ ensures \result == x * y;
  @*/
int mul(int x, int y) {
  int r = 0;
  /*@
    @ loop assigns r, y;
    @ loop invariant r + x * y == \at(x, Pre) * \at(y, Pre);
    @ loop variant \abs(y);
    @*/
  while (y != 0) {
    if (0 < y) { r += x; y -= 1; }
    else { r -= x; y += 1; }
  }
  return r;
}
