
/*@
  @ axiomatic Nist {
  @   logic integer nist(integer n);
  @   axiom nist1 : \forall integer n; n < 2 ==> nist(n) == n;
  @   axiom nist2 : \forall integer n; !(n < 2) ==> nist(n) == nist(n - 2) + 2 * nist(n - 1);
  @ }
  @*/

/*@
  @ requires 0 <= n;
  @ ensures n <= \result;
  @ assigns \nothing;
  @*/
int nist_impl(int n) {
  int x = 0, y = 1, i = 0;
  /*@
    @ loop invariant 0 <= i <= n;
    @ loop invariant x == nist(i);
    @ loop invariant y == nist(i + 1);
    @ loop assigns x, y, i;
    @*/
  for (i = 0; i < n; i++) {
    int tmp = x;
    x = y;
    y = tmp + 2 * y;
  }
  return x;
}
