#include <stdint.h>

const int16_t P = 7681;
const int16_t ZETA = 3777;
const int16_t ZETA_PINV = 28865;

/*@
  @ requires \valid(r1) && \valid(r2);
  @ requires \separated(r1, r2, &P, &ZETA, &ZETA_PINV);
  @ requires (-4096 < f000 < 4096);
  @ requires (-4096 < f128 < 4096);
  @ assigns *r1, *r2;
  @*/
void foo(const int16_t f000, const int16_t f128, int16_t *r1, int16_t *r2) {
  int16_t f128_mul_zeta_pinv_low = (int16_t)((int32_t)ZETA_PINV * f128);
  int32_t f128_mul_zeta = (int32_t)ZETA * f128;
  int16_t f128_mul_zeta_high = (int16_t)(f128_mul_zeta >> 16);
  int32_t f128_mul_zeta_pinv_low_mul_p = (int32_t)f128_mul_zeta_pinv_low * P;
  //@ assert((int16_t)f128_mul_zeta_pinv_low_mul_p == (int16_t)f128_mul_zeta);
  int16_t f128_mul_zeta_pinv_low_mul_p_high = (int16_t)(f128_mul_zeta_pinv_low_mul_p >> 16);
  *r1 = f000 + f128_mul_zeta_high - f128_mul_zeta_pinv_low_mul_p_high;
  *r2 = f000 - f128_mul_zeta_high + f128_mul_zeta_pinv_low_mul_p_high;
}

int main(void) {
  int16_t f000 = 123, f128 = 567, r1, r2;
  foo(f000, f128, &r1, &r2);
  return 0;
}
