
/*@ requires \valid(a) && \valid(b);
  @ ensures *a == \old(*b) && *b == \old(*a);
  @ assigns *a, *b;
  @*/
void swap(int *a, int *b)
{
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

/*@
  @ requires \valid(a) && \valid(b) && \valid(c) && \separated(a, b, c);
  @ ensures *a <= *b <= *c;
  @ ensures { *a, *b, *c } == { \old(*a), \old(*b), \old(*c) };
  @ assigns *a, *b, *c;
  @*/
void order3(int *a, int *b, int *c) {
  if (*a > *b) swap(a, b);
  if (*a > *c) swap(a, c);
  if (*b > *c) swap(b, c);
}
